<?php
/*
This file is part of the inventory module, written by Franky Van Liedekerke for
more.groupware
Contact: liedekef@pandora.be
                                                                                
The inventory module is distributed under the terms of the GNU General Public License
                                                                                
The inventory module is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
The inventory module is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this module; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


require_once("setup-base.php");

$action="";
if (isset($_REQUEST["action"]))
	$action=$_REQUEST["action"];

if (isset($_REQUEST["categoryid"])) {
   $category=new inv_Category($_REQUEST["categoryid"]);
} else {
   $category=new inv_Category();
}
if (isset($_REQUEST["colid"])) {
   $column=new inv_Column($_REQUEST["colid"]);
} else {
   $column=new inv_Column();
}
if (isset($_REQUEST["productid"])) {
   $product=new inv_Product($_REQUEST["productid"]);
} else {
   $product=new inv_Product();
}
if (isset($_REQUEST["locationid"])) {
   $location=new inv_Location($_REQUEST["locationid"]);
} else {
   $location=new inv_Location();
}

if (!queryRights2_bool('root_modules_inventory_admin')) {
    $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
    $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
    $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
    exit();
}

if ($action == "adminlocs") {
    $location->admin_locs();
    exit;
}
if ($action == "admincols") {
    $column->admin_cols();
    exit;
}
if ($action == "admincats") {
    $category->admin_cats();
    exit;
}
if ($action == "adminprods") {
    $product->admin_prods();
    exit;
}
if ($action == "update_location_preference") {
    $location->admin_updatepreference();
    redirect("admin.php?action=adminlocs");
}
if ($action == "update_category_displayorder") {
    $category->admin_updatedisplayorder();
    redirect("admin.php?action=admincats");
}
if ($action == "update_column_displayorder") {
    $column->admin_updatedisplayorder();
    redirect("admin.php?action=admincols");
}

if ($action == "newloc" || $action == "editloc" || $action == "delloc" || $action == "viewloc") {
    $location->modify_location($action);
    exit;
}

if (isset($_POST["newloc"]) and !empty($_POST["newloc"])) {
    $location->opUpdate();
    redirect("admin.php?action=adminlocs");
}
if (isset($_POST["editloc"]) and !empty($_POST["editloc"])) {
    $location->opUpdate();
    redirect("admin.php?action=adminlocs");
}
if (isset($_POST["delloc"]) and !empty($_POST["delloc"])) {
    $location->opDelete();
    redirect("admin.php?action=adminlocs");
}

if ($action == "newcat" || $action == "editcat" || $action == "delcat" || $action == "viewcat") {
    $category->modify_category($action);
    exit;
}

if (isset($_POST["newcat"]) and !empty($_POST["newcat"])) {
    $category->opUpdate();
    redirect("admin.php?action=admincats");
}
if (isset($_POST["editcat"]) and !empty($_POST["editcat"])) {
    $category->opUpdate();
    redirect("admin.php?action=admincats");
}
if (isset($_POST["delcat"]) and !empty($_POST["delcat"])) {
    $category->opDelete();
    redirect("admin.php?action=admincats");
}

if ($action == "newcol" || $action == "editcol" || $action == "delcol" || $action == "viewcol") {
    $column->modify_column($action);
    exit;
}

if (isset($_POST["newcol"]) and !empty($_POST["newcol"])) {
    $column->opUpdate();
    redirect("admin.php?action=admincols");
}
if (isset($_POST["editcol"]) and !empty($_POST["editcol"])) {
    $column->opUpdate();
    redirect("admin.php?action=admincols");
}
if (isset($_POST["delcol"]) and !empty($_POST["delcol"])) {
    $column->opDelete();
    redirect("admin.php?action=admincols");
}

if ($action == "newprod" || $action == "editprod" || $action == "disableprod" || $action == "viewprod") {
    $product->modify_product($action);
    exit;
}
if (isset($_POST["newprod"]) and !empty($_POST["newprod"])) {
    $product->opUpdate();
    redirect("admin.php?action=adminprods");
}
if (isset($_POST["editprod"]) and !empty($_POST["editprod"])) {
    $product->opUpdate();
    redirect("admin.php?action=adminprods");
}
?>
