<?php
/*
This file is part of the inventory module, written by Franky Van Liedekerke for
more.groupware
Contact: liedekef@pandora.be
                                                                                
The inventory module is distributed under the terms of the GNU General Public License
                                                                                
The inventory module is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
The inventory module is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this module; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


    function inventory_AddHistory ($itemid,$text) {
	global $conn;
	$lu_date = $conn->DBTimeStamp(time());
	if (isset($_SESSION["MGW"]->userid)) {
	   $userid = $_SESSION["MGW"]->userid;
	} else {
	   $userid=-1;
	}

	$sql="INSERT INTO mgw_inventory_itemhistory (itemid,userid,text,lu_date) VALUES ($itemid,".$conn->Quote($userid).",".$conn->Quote($text).",$lu_date)";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function inventory_GetHistory ($itemid) {
	global $conn;
	$sql="SELECT * FROM mgw_inventory_itemhistory WHERE itemid=$itemid)";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row = $res->FetchRow()) {
		$array[] = $row;
	}
	return $array;
    }

    function inventory_categoryproductlist ($categoryid=0) {
	global $conn;
	if ($categoryid) {
	    $sql="SELECT * FROM mgw_inventory_product WHERE categoryid=$categoryid";
	} else {
	    $sql="SELECT * FROM mgw_inventory_product";
	}
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$array=array();
	while ($row = $res->FetchRow()) {
		$array[] = $row;
	}
	return $array;
    }

    function inventory_locationproductlist ($locationid=0) {
	global $conn;

	$sql="SELECT DISTINCT prod.* FROM mgw_inventory_item item, mgw_inventory_product prod WHERE prod.productid=item.productid AND item.locationid=$locationid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$array=array();
	while ($row = $res->FetchRow()) {
		$array[] = $row;
	}

	return $array;
    }

    function inventory_admin_productlist () {
	global $conn;

	$sql="SELECT * FROM mgw_inventory_product ORDER BY categoryid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$array=array();
	while ($row = $res->FetchRow()) {
		$row["categorytitle"]=inventory_categorytitle($row["categoryid"]);
		$array[] = $row;
	}

	return $array;
    }

    function inventory_locationlist () {
	global $conn;
	$sql="SELECT * FROM mgw_inventory_locations ORDER BY preference";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$array=array();
	while ($row = $res->FetchRow()) {
		$array[] = $row;
	}
	return $array;
    }

	// function for recursion
	function categoryarrayrek(&$array, $parentid, $depth) {
		global $conn;

		$sql = "SELECT * FROM mgw_inventory_category WHERE parentid='".$parentid."' ORDER BY displayorder";
		if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
		while ($cat = $res->FetchRow()) {
			$cat["depth"] = $depth;
			$array[] = $cat;
			// recursion
			categoryarrayrek($array, $cat["categoryid"], $depth+1);
		}
	}
    function inventory_categorylist ($parentid=0, $depth=0) {

	# empty array
	$array = array();
	# fill the array
	categoryarrayrek($array,$parentid,$depth);

	return $array;
    }

    function inventory_make_categorysb ($formname,$categoryid=0,$dont_show_catid=0) {
	$categorylist=array();
	$categorylist=inventory_categorylist();
	$sb="<SELECT NAME=$formname>";
	$sb.="<OPTION VALUE=0>";
	foreach ($categorylist as $key => $value) {
	    if ($dont_show_catid && $value["categoryid"]==$dont_show_catid) {
		continue;
	    }
	    // if depth is 0, first show a blank line
	    if ($value["depth"]==0) {
		 $sb.="<OPTION VALUE=0>";
	    }
	    // if categoryonly, surround the title by square brackets
	    // and set the value of categoryid to 0 (checked onsubmit when
	    //    doing an edit of a product)
	    // we save the original value of the categoryid to determine
	    // which category was selected
	    $tmp_categoryid=$value["categoryid"];
	    if ($value["categoryonly"]==1) {
		    $value["categoryid"]=0;
		    $value["categorytitle"]="[".$value["categorytitle"]."]";
	    }
	    $sb.="<OPTION VALUE=".$value["categoryid"];
	    if ($categoryid && $tmp_categoryid==$categoryid) {
		$sb.=" SELECTED";
	    }
	    $sb.=">";
	    for ($i = 1; $i <= $value["depth"]; $i++) {
	        $sb.="&nbsp;&nbsp;";
	    }
	    $sb.=$value["categorytitle"];
	}
	$sb.="</SELECT>";
	return $sb;
    }

    function inventory_collist() {
	global $conn;
	$collist=array();
	$sql="SELECT * FROM mgw_inventory_col";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row = $res->FetchRow()) {
		$collist[]=$row;
	}
	return $collist;
    }

    function inventory_all_coltypes ($coltypeid) {
	global $coltypes;
	include_once(INCLUDEPATH . "mSelectBox.class.php");
	$sb = new mSelectBox("coltypeid",$coltypeid);
	$sb->setContentType("arr");
	$sb->addContent($coltypes);
	return $sb->draw();
    }

    function inventory_make_locationsb ($locationid=0) {
	global $coltypes;
	include_once(INCLUDEPATH . "mSelectBox.class.php");
	$sql="SELECT locationid, locationtitle FROM mgw_inventory_locations"; 
	$sb = new mSelectBox("locationid",$locationid);
	$sb->setContentType("sql");
        $sb->setSQLvalue("locationid");
        $sb->setSQLcontent("locationtitle");
	$sb->addContent($sql);
	return $sb->draw();
    }

    function inventory_render_column_input_field ($col,$fixedvalue,$value, $small_input=0,$name="") {
	global $conn;
	global $coltypes;
	include_once(INCLUDEPATH . "mSelectBox.class.php");
    
	if (!empty($fixedvalue)) {
	    $fixed=1;
	    $col_value=$fixedvalue;
	} else {
	    $fixed=0;
            if (empty($value)) {
                $col_value=$col["default_val"];
            } else {
                $col_value=$value;
            }
	}

	if (!empty($name)) {
	   $formname=$name;
	} else {
	   $formname="col[".$col["colid"]."]";
	}
        switch($coltypes[$col["coltypeid"]]) {
            case 'varchar':
		if ($small_input) {
		    $colsize=20;
		} else {
		    $colsize=$col["size"];
		}
		if ($fixed) {
		   $res =  " <INPUT TYPE=\"TEXT\" READONLY NAME=".$formname.
			" VALUE=\"".htmlspecialchars($col_value)."\" SIZE=".$colsize.
			" MAXLENGTH=".$col["size"].">";
		} else {
		   $res =  " <INPUT TYPE=\"TEXT\" NAME=".$formname.
			" VALUE=\"".htmlspecialchars($col_value)."\" SIZE=".$colsize.
			" MAXLENGTH=".$col["size"].">";
		}
		break;
            case 'textarea':
		if ($small_input) {
		    $rows=1;
		    $cols=20;
		} else {
		    $rows=5;
		    $cols=20;
		}
		if ($fixed) {
		   $res = " <TEXTAREA WRAP=VIRTUAL READONLY NAME=".$formname.
			" ROWS=$rows COLS=$cols>".htmlspecialchars($col_value).
			"</TEXTAREA>";
		} else {
		   $res = " <TEXTAREA WRAP=VIRTUAL NAME=".$formname.
			" ROWS=$rows COLS=$cols>".htmlspecialchars($col_value).
			"</TEXTAREA>";
		}
		break;
            case 'dropdown':
		$tmp_arr=array();
		$tmp2_arr=array();
		if (isset($col["override_possible_vals"]) && count($col["override_possible_vals"])>0) {
		   $tmp_arr=explode(",",$col["override_possible_vals"]);
		} else {
		   $tmp_arr=explode(",",$col["possible_vals"]);
		}
		// for fixed values, we show a dropdown with only one field
		if ($fixed) {
		   $tmp2_arr["$col_value"]="$col_value";
		} else {
		   foreach ($tmp_arr as $tmp_key => $value) {
		      $value=htmlspecialchars($value);
		      $tmp2_arr["$value"]="$value";
		   }
		}
		$sb = new mSelectBox($formname,$col_value);
		$sb->setContentType("arr");
		$sb->addContent($tmp2_arr);
		$res=$sb->draw();
		unset($sb,$tmp_arr,$tmp2_arr);
		break;
            case 'sqldropdown':
		if (count($col["override_possible_vals"])>0) {
		   $sql=$col["override_possible_vals"];
		} else {
		   $sql=$col["possible_vals"];
		}
		if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
		$tmp_arr=array();
		while ($row=$res->FetchRow()) {
		    // we can only show 1 value, so we take the first
		    // column returned by the query
		    $sql_tablenames=array_keys($row);
		    $sql_tablename=$sql_tablenames[0];

		    // for fixed values, we show a dropdown with only one field
		    if ($fixed && $row[$sql_tablename] != $col_value) {
			continue;
		    }
		    $tmp_value=htmlspecialchars($row[$sql_tablename]);
		    $tmp_arr["$tmp_value"]="$tmp_value";
		}

		$sb = new mSelectBox($formname,$col_value);
		$sb->setContentType("arr");
		$sb->addContent($tmp_arr);
		$res=$sb->draw();
		unset($sb,$tmp_arr);
		break;
	}
	return $res;
    }

    function inventory_categorytitle ($categoryid) {
	global $conn;
        $result=$conn->GetOne("SELECT categorytitle FROM mgw_inventory_category WHERE categoryid = $categoryid");
	return ($result);
    }
?>
