<?php
/*
This file is part of the inventory module, written by Franky Van Liedekerke for more.groupware
Contact: liedekef@pandora.be

The inventory module is distributed under the terms of the GNU General Public License
                                                                                
The inventory module is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
The inventory module is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this module; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require_once("setup-base.php");

$action="";
if (isset($_REQUEST["action"]))
	$action=$_REQUEST["action"];

if (isset($_REQUEST["categoryid"])) {
    $categoryid=(int)$_REQUEST["categoryid"];
    $category=new inv_Category($categoryid);
} else {
    $categoryid=0;
    $category=new inv_Category();
}

if (isset($_REQUEST["productid"])) {
    $productid=(int)$_REQUEST["productid"];
    $product=new inv_Product($productid);
} else {
    $productid=0;
    $product=new inv_Product();
}

if (isset($_REQUEST["locationid"])) {
    $locationid=(int)$_REQUEST["locationid"];
    $location=new inv_Location($locationid);
} else {
    $locationid=0;
    $location=new inv_Location($locationid);
}

if (isset($_REQUEST["itemid"])) {
    $item=new inv_Item((int)$_REQUEST["itemid"],$productid,$locationid);
} else {
    $item=new inv_Item(0,$productid,$locationid);
}

if (isset($_REQUEST["search"]) and !empty($_REQUEST["search"])) {
    $tmp_id=(int)$_REQUEST["colid"];
    if ($tmp_id==-1) {
	$new_item=new inv_Item((int)$_REQUEST["itemvalue"]);
	$new_item->modify("viewitem");
	exit;
    }
    // the rest of the cases is handled by the viewitems function
}


if (isset($_POST["newitem"]) and !empty($_POST["newitem"])) {
    $item->opUpdate();
    redirect("index.php?action=viewitems&productid=$productid");
}
if (isset($_POST["edititem"]) and !empty($_POST["edititem"])) {
    $item->opUpdate();
    redirect("index.php?action=viewitems&productid=$productid");
}
if (isset($_POST["delitem"]) and !empty($_POST["delitem"])) {
    $item->opDelete();
    redirect("index.php?action=viewitems&productid=$productid");
}

if (isset($_POST["moveitem"]) and !empty($_POST["moveitem"])) {
    $item->opMove((int)$_POST["locationid"]);
    redirect("index.php?action=viewitems&productid=$productid");
}

if ($action == "viewitems") {
    $item->viewitems();
    exit;
}

if ($action == "viewcategoryproducts") {
    $product->viewcategoryproducts($categoryid);
    exit;
}

if ($action == "viewlocationproducts") {
    $product->viewlocationproducts($locationid);
    exit;
}

if ($action == "viewlocations") {
    $location->viewlocations();
    exit;
}

if ($action == "edititem" || $action == "delitem" || $action == "newitem" || $action == "viewitem") {
    $item->modify($action);
    exit;
}

if (isset($_POST["moveprod"]) and !empty($_POST["moveprod"])) {
    $item->opMove($categoryid);
    redirect("index.php?action=viewproducts&categoryid=$categoryid");
}


$smarty->assign("categorylist",inventory_categorylist());
$smarty->display("inventory_category_list.tpl",$user);
?>
