<?php

  /*
   This file is part of MoreGroupWare's webmail2 module
   Copyright 2004-2005 Franky Van Liedekerke
   This module is released under the GPL (as stated below).

   Originally written by Thomas Bley (info@simple-groupware.de),
   now adapted and maintained by Franky Van Liedekerke.

   You should have received a copy of the GNU General Public License
   along with mgw; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

function smarty_remove_all_links($tpl_source, &$smarty) {
  $tpl_source = preg_replace(array("'<noscript>.*?</noscript>'si"),array(""),$tpl_source);
  $tpl_source = str_replace(array("norefer.php?url=","noimg.php?download=0&url=","noimg.php?download=1&url=","&nbsp;"),"",$tpl_source);
  return $tpl_source;
}

function wm2_unzip($act_name,$filename,$output_file) {
  global $MGW;
  if ($output_file=="") {
    $safetmpfname = tempnam ("", "mgw_wm2_unzip_");
    $cmd = $MGW->settings["wm2_unzip"]." -p ".$act_name." ".$filename." >".$safetmpfname;
    passthru($cmd);

    $fp = fopen($safetmpfname, "r");
    $text = fread ($fp, filesize ($safetmpfname));
    fclose($fp);
    unlink($safetmpfname);

    return $text;
  } else {
    $cmd = $MGW->settings["wm2_unzip"]." -p ".$act_name." ".$filename." >".$output_file;
    passthru($cmd);
  }
}

function verify_gpg($body) {
  global $MGW;

  $safetmpfname = tempnam ("", "mgw_wm2_checkgpg_");

  $keyserver = ((isset($MGW->settings["wm2_gpg_keyserver"]) and $MGW->settings["wm2_gpg_keyserver"]!="")?" --keyserver ".$MGW->settings["wm2_gpg_keyserver"]:"");

  $output = "";
  $text = "Invalid PHP-Version: < 4.30";
  if (str_replace(".","",PHP_VERSION)>=430) {
    $descriptorspec = array( 0 => array("pipe", "r"), 1 => array("pipe", "w"), 2 => array("file", $safetmpfname, "a"));
    $process = proc_open($MGW->settings["wm2_gpg_prog"].$keyserver." --no-default-keyring --secret-keyring ".$MGW->settings["wm2_gpg_secring"]." --keyring ".$MGW->settings["wm2_gpg_pubring"]." --batch --no-tty --always-trust --quiet --no-verbose --textmode", $descriptorspec, $pipes);
    if (is_resource($process)) {
      fwrite($pipes[0], $body);
      fclose($pipes[0]);
      while(!feof($pipes[1])) {
        $output .= fgets($pipes[1], 1024);
      }
      fclose($pipes[1]);
      $return_value = proc_close($process);
    }
    $fp = fopen($safetmpfname, "r");
    $text = fread ($fp, filesize ($safetmpfname));
    fclose($fp);
    unlink($safetmpfname);
  }
  $text = str_replace(array("'","\"","\n","\r"),array("","","\\n","\\n"),$text);

  if (strpos(strtolower($text),"good signature")) {
    return array(true, $text, $output);
  } else {
    return array(false, $text, $output);
  }
}

function decrypt_gpg($body) {
  global $MGW,$user_id,$username;

  $filename = CACHE_FOLDER."$username/gpg/keys.gpg";
  if (file_exists($filename)) { unlink($filename); }

  $fd = fopen($filename, "wb");
  fwrite($fd,$body);
  fclose($fd);
  
  $safetmpfname = tempnam ("", "mgw_wm2_checkgpg_");

  $keyserver = ((isset($MGW->settings["wm2_gpg_keyserver"]) and $MGW->settings["wm2_gpg_keyserver"]!="")?" --keyserver ".$MGW->settings["wm2_gpg_keyserver"]:"");
  $passphrase = ((isset($MGW->settings["wm2_gpg_passphrase"]) and $MGW->settings["wm2_gpg_passphrase"]!="")?" --passphrase-fd 0":"");
  
  $output = "";
  $text = "Invalid PHP-Version: < 4.30";
  if (str_replace(".","",PHP_VERSION)>=430) {
    $descriptorspec = array( 0 => array("pipe", "r"), 1 => array("pipe", "w"), 2 => array("file", $safetmpfname, "a"));
    $process = proc_open($MGW->settings["wm2_gpg_prog"].$keyserver." ".$passphrase." --no-default-keyring --secret-keyring ".$MGW->settings["wm2_gpg_secring"]." --keyring ".$MGW->settings["wm2_gpg_pubring"]." --batch --no-tty --no-verbose --textmode --output - --always-trust ".CACHE_FOLDER."$username/keys.gpg", $descriptorspec, $pipes);
    if (is_resource($process)) {
      if (isset($MGW->settings["wm2_gpg_passphrase"]) and $MGW->settings["wm2_gpg_passphrase"]!="") {
	fwrite($pipes[0], $MGW->settings["wm2_gpg_passphrase"]);
      }
      fclose($pipes[0]);
      while(!feof($pipes[1])) {
        $output .= fgets($pipes[1], 1024);
      }
      fclose($pipes[1]);
      $return_value = proc_close($process);
    }
    $fp = fopen($safetmpfname, "r");
    $text = fread ($fp, filesize ($safetmpfname));
    fclose($fp);
    unlink($safetmpfname);
  }
  $text = str_replace(array("'","\"","\n","\r"),array("","","\\n","\\n"),$text);

  if (file_exists($filename)) { unlink($filename); }
  
  if (strpos(strtolower($text),"bad passphrase")) {
    return array(false, $text, $output);
  } else {
    return array(true, $text, $output);
  }
}

//function quotedPrintableDecode($input)
//{
//  // Remove soft line breaks
//  $input = preg_replace("/=\r?\n/", '', $input);
//
//  // Replace encoded characters
//  if (preg_match_all('/=[a-f0-9]{2}/i', $input, $matches)) {
//    $matches = array_unique($matches[0]);
//    foreach ($matches as $value) {
//      $input = str_replace($value, chr(hexdec(substr($value,1))), $input);
//    }
//  }
//  return $input;
//}

//function findboundary2($line,$boundarys) {
//  $length = strlen($line);
//  $result = false;
//  if ($length>10) { //  and $length<81
//    if (substr($line,0,2)=="--") {
//      $line = str_replace("\r","",$line);
//      foreach ($boundarys as $boundary) {
//	if ($boundary!="" and ("--".$boundary==$line or "--".$boundary."--"==$line)) { 
//	  $result = true;
//	  break;
//	}
//      }
//    }
//  }
//  return $result;
//}

//function make_proto2($line) {
//  global $filename;
//  if ($line == "") { $line = "@leer@"; }
//  echo htmlspecialchars($line);
//  if (strlen($line)<8) {
//    for ($i=0;$i < strlen($line);$i++) {
//      echo ord($line[$i]).",";
//    }
//  }
//  if ($filename != "") {echo " - ".$filename."<br>\n";} else { echo "<br>\n"; }
//}        
                
function create_filename($filename, $account, $msg_no, $partno) {
  global $msg_cache, $mime_types, $username, $message_id;

  $ext = strtolower(substr($filename,-strpos(strrev($filename),'.')));
  if (isset($mime_types[$ext][0]) and $mime_types[$ext][0]=="img") { $addon = "img"; } else {$addon = "attachments";}
  if ($account == 0) { $act_name = CACHE_FOLDER."$username/$addon/$msg_no"."-".$msg_cache."-".$partno."-".$filename; }
  else { $act_name = CACHE_FOLDER."$username/imap/$addon/$message_id"."-".$partno."-".$filename; }

  return $act_name;
}

function add_filename_to_list($filename, $realname, $msg_no, $partno) {
   global $mime_types;

   $att_size=0;
   if (file_exists($filename)) { $att_size = filesize($filename); }

   $ext = strtolower(substr($filename,-strpos(strrev($filename),'.')));
   if ((!isset($mime_types[$ext])) or (isset($mime_types[$ext]) and $mime_types[$ext][1]=="danger")) {
    $message[0] = '<br><font color="#ff0000"><b>'.Lang::getLanguageString("webmail2_func_virus1").'</b></font>';
    $message[1] = Lang::getLanguageString("webmail2_func_virus2");
    $danger = "yes";
  } else {$danger = "no"; $message="";}

  $safe_name=basename($realname);
  $result= array($safe_name,format_filesize($att_size),$message,$msg_no,$partno,$danger);
  return $result;
}

function make_emailbox_array($structure) {
   global $MGW, $notify;
   global $account, $msg_no;

   $my_body_plain="";
   $my_body_show="";
   $mail_attachments=array();
   $mail_structure=array();

   if (isset($structure->headers["disposition-notification-to"]) and $structure->headers["disposition-notification-to"]!="") $notify = true;

   if (!isset($structure->headers['x-priority'])) {$priority = "";} else {
      if (is_array($structure->headers['x-priority'])) {
         $priority = htmlspecialchars($structure->headers['x-priority'][0]);
      } else {
         $priority = htmlspecialchars($structure->headers['x-priority']);
      }
   }
   if (!isset($structure->headers['from'])) {$from = "";} else {
        if (is_array($structure->headers['from'])) {
           $from = decode_mime_string(htmlspecialchars($structure->headers['from'][0]));
        } else {
           $from = decode_mime_string(htmlspecialchars($structure->headers['from']));
        }
   }
   if (!isset($structure->headers['subject'])) {$subject = "";} else {
        if (is_array($structure->headers['subject'])) {
           $subject = decode_mime_string(htmlspecialchars($structure->headers['subject'][0]));
        } else {
           $subject = decode_mime_string(htmlspecialchars($structure->headers['subject']));
        }
   }
   if (!isset($structure->headers['to'])) {$to = "";} else {
      if (is_array($structure->headers['to'])) {
         $to = implode($structure->headers['to'],", ");
      } else {
         $to = htmlspecialchars($structure->headers['to']);
      }
   }
   if (!isset($structure->headers['bcc'])) {$bcc = "";} else {
      if (is_array($structure->headers['bcc'])) {
         $bcc = implode($structure->headers['bcc'],", ");
      } else {
         $bcc = htmlspecialchars($structure->headers['bcc']);
      }
   }
   if (!isset($structure->headers['cc'])) {$cc = "";} else {
      if (is_array($structure->headers['cc'])) {
         $cc = implode($structure->headers['cc'],", ");
      } else {
         $cc = htmlspecialchars($structure->headers['cc']);
      }
   }
   if (!isset($structure->headers['date'])) {$date = "";} else {
      if (is_array($structure->headers['date'])) {
           $date = htmlspecialchars($structure->headers['date'][0]);
      } else {
           $date = htmlspecialchars($structure->headers['date']);
      }
   }
   if (!isset($structure->headers['reply-to'])) {$replyto = "";} else {
      if (is_array($structure->headers['reply-to'])) {
	$replyto = htmlspecialchars($structure->headers['reply-to'][0]);
      } else {
	$replyto = htmlspecialchars($structure->headers['reply-to']);
      }
   }

   if (!isset($gpg_signature)) $gpg_signature = array();
   if (!isset($gpg_decrypt)) $gpg_decrypt = array();

   // if just plain text, then there are no parts, we then create one
//   if (!isset($structure->parts)) {
	// TTT
 //     $structure->parts[0]=$structure;
 //  }
    if (!isset($structure->parts)) {
      $structure->parts[0]->headers=$structure->headers;
      if (isset($structure->ctype_primary)) {
         $structure->parts[0]->ctype_primary=$structure->ctype_primary;
      }
      if (isset($structure->ctype_secondary)) {
         $structure->parts[0]->ctype_secondary=$structure->ctype_secondary;
      }
      if (isset($structure->ctype_parameters)) {
         $structure->parts[0]->ctype_parameters=$structure->ctype_parameters;
      }
      if (isset($structure->body)) {
         $structure->parts[0]->body=$structure->body;
      }
      $structure->parts[0]->parts=array();
    }


   // the next couple of lines are to remove text parts when both
   // text and html versions are available
   $html_found=0;
   $text_found=0;
   $text_index=0;
   $html_index=0;
   foreach ($structure->parts as $key=>$part) {
      $ctype_full="";
      if (isset($part->ctype_primary) && isset($part->ctype_secondary)) {
         $ctype_full=strtolower($part->ctype_primary)."/".strtolower($part->ctype_secondary);
      }
      if ($ctype_full=="text/plain") {
         $text_found=1;
	 $text_index=$key;
      }
      if ($ctype_full=="text/html") {
         $html_found=1;
	 $html_index=$key;
      }
   }

   // for multipart/alternative, we use only the html part
   // don't we need to check the preferences here?
   if ($structure->ctype_primary=="multipart" && $structure->ctype_secondary=="alternative" &&
       $html_found && $text_found) {
      unset($structure->parts[$text_index]);
   }
   // end of code to remove text part when html and text parts are there


   $partno=0;
   foreach ($structure->parts as $part) {
	// the next happens when you send mail both as text and html
	// and with attachments
	// sometimes there is a parts[2] as well, but for now I'll leave this
     if (isset($part->parts) && isset($part->parts[1]) && isset($part->parts[2]) && strtolower($part->parts[2]->ctype_primary)=="text" && (strtolower($part->parts[2]->ctype_secondary)=="html" || strtolower($part->parts[2]->ctype_secondary)=="enriched")) {
	$part = $part->parts[2];
     } else if (isset($part->parts) && isset($part->parts[1])) {
	if (strtolower($part->parts[1]->ctype_primary)=="text" && (strtolower($part->parts[1]->ctype_secondary)=="html" || strtolower($part->parts[1]->ctype_secondary)=="enriched")) {
	   $part = $part->parts[1];
	} else if (empty($part->parts[0]->body)) {
	   $part = $part->parts[1];
	} else {
           $part = $part->parts[0];
	}
     }

     if (isset($part->ctype_primary) && isset($part->ctype_secondary)) {
        $ctype_full=strtolower($part->ctype_primary)."/".strtolower($part->ctype_secondary);
     } else {
	$ctype_full="text/plain";
     }

     if (isset($part->disposition)) {
        $dispo = " (".strtolower($part->disposition).")";
     } else {
        $dispo = "";
     }
     if (isset($part->d_parameters["filename"])) {
        $name = strtolower($part->d_parameters["filename"]);
     } elseif (isset($part->ctype_parameters["name"])) {
        $name = strtolower($part->ctype_parameters["name"]);
     } elseif (isset($part->headers['content-id']) && $part->ctype_primary != 't
ext') {
        $name = $part->headers['content-id'] . "." . $part->ctype_secondary;
     } else {
        $name = "";
	$dispo2 = "";
     }

     // since the mime decoding doesn't do utf8 decoding, we need to do thi
     // ourselves. So every text/html or text/plain will get utf8 decoded
     // if it needs to be done
     $needs_utf8_decoding=0;
     if (isset($part->ctype_parameters["charset"]) &&
	 $part->ctype_parameters["charset"]=="utf-8") {
	 $needs_utf8_decoding=1; 
     }

     // make the name safe
     $name = preg_replace("/script(\:|\>)|http.?\:|ftp\:|\/|<|>|:/i","",$name);
     $name = preg_replace("/ /","_",$name);
     $dispo2 = " ($name)";
     $mail_structure[] = $ctype_full.$dispo.$dispo2." ".$partno;

     if ($ctype_full=="multipart/alternative" || $ctype_full=="multipart/mixed") {
        foreach ($part->parts as $party) {
	   list($tmp_body_plain,$tmp_body_show,$tmp_result)=make_emailbox_array($party);
           $my_body_show.=$tmp_body_show;
           $my_body_plain.=$tmp_body_plain;
        }
     } elseif ($ctype_full=="message/rfc822") {
        foreach ($part->parts as $party) {
	   list($tmp_body_plain,$tmp_body_show,$tmp_result)=make_emailbox_array($party);
           $my_body_show.=make_emailbox_html($tmp_result);
           $my_body_show.=$tmp_body_show;
           $my_body_plain.=$tmp_body_plain;
	}
     // only save if an attachment
     } elseif ((isset($part->disposition) || isset($part->headers['content-id'])|| (isset($part->ctype_primary) and $part->ctype_primary!='text' and !isset($part->disposition))) and ($name != "")) {
        $filename=create_filename($name, $account, $msg_no, $partno);
        $fp = $filename;
	$fp = fopen($filename, "wb");
        fwrite($fp, $part->body);
        fclose($fp);
	$mail_attachments[]=add_filename_to_list($filename, $name, $msg_no, $partno);
        if ($part->ctype_primary=='image' && $MGW->settings["wm2_enableinline"]) {
	   // if cid url is found then insert image entries otherwise append
	   // them in a table (the setting wether or not to download external
	   // images is not important for cid replacement)
	   // this code is disabled because one can use div layers
	   // and screw the whole page up ...
	   //if (isset($part->headers['content-id']) &&
	   //   (strpos($my_body_show,'src="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=cid:' . preg_replace("/<|>/","",$part->headers['content-id'])) !== FALSE)) {
           //       $my_body_show = str_replace('src="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=cid:' . preg_replace("/<|>/","",$part->headers['content-id']),'src="' . $filename, $my_body_show);
           //} else {
              $my_body_show .= '<table cellpadding="1" cellspacing="0" border="0" bgcolor="#4E4E4E"><tr><td><table bgcolor="#F3F3F3" border="0" cellpadding="0" cellspacing="0"><tr><td><img src="'.$filename.'" border="0" title="'.$name.'" onload="return_width(this);"></td></tr></table></td></tr></table>';
           //}
	}
     } elseif ($ctype_full=="text/calendar") {
	if ($name == "") {
	   $name="appointment.ics";
	}
        $filename=create_filename($name, $account, $msg_no, $partno);
        $fp = $filename;
	$fp = fopen($filename, "wb");
        fwrite($fp, $part->body);
        fclose($fp);
	$mail_attachments[]=add_filename_to_list($filename, $name, $msg_no, $partno);
     } elseif ($ctype_full=="text/html" || $ctype_full=="text/enriched") {
	if ($ctype_full=="text/enriched") {
	   include_once WM2_INC_DIR."decode_enriched.inc.php";
	   $part->body = enriched_to_html($part->body);
	}
	// only keep the part between "<body...> and </body>"
        $part->body = preg_replace("/^.*<body[^>]*?>(.*)<\/body.*$/si","\\1",$part->body);
	if ($needs_utf8_decoding) {
	   $part->body=utf8_decode($part->body);
	}
        $my_body_show .= modify_html(trim($part->body))."<br>";
        $text = strip_tags(str_replace("<br>","#mybr#",trim($part->body)));
        $text = preg_replace("/(\015\012)|(\015)|(\012)/","",$text);
        $text = str_replace("#mybr#","\r\n",$text);
        $text = my_decodeHTML($text);
        $my_body_plain .= $text;
     } elseif ($ctype_full=="text/plain" || $ctype_full=="application/pgp-signature") {
        if (isset($MGW->settings["wm2_gpg_use"]) and $MGW->settings["wm2_gpg_use"] and (strpos(substr($body2,0,100),"BEGIN PGP MESSAGE") or 
        strpos(substr($body2,0,100),"BEGIN PGP SIGNED MESSAGE"))) {
          if (file_exists($MGW->settings["wm2_gpg_prog"]) and file_exists($MGW->settings["wm2_gpg_pubring"]) and file_exists($MGW->settings["wm2_gpg_secring"])) {

            $results = decrypt_gpg($part->body);
            if ($results[0]) {
              $my_body_show .= modify_text(htmlspecialchars(trim($results[2])))."<br>";
            }
          } else {
            $my_body_show .= "ERROR: Could not find gpg/pubring/secring.";
          }
        } else {
	  if (isset($part->body)) {
	     if ($needs_utf8_decoding) {
	        $part->body=utf8_decode($part->body);
	     }
	     $my_body_show .= modify_text(htmlspecialchars(trim($part->body)))."<br>";
	   }
	}
	if (isset($part->body)) {
          $my_body_plain .= $part->body;
	}
     } else {
	// default: show it
	if (isset($part->body)) {
	   if ($needs_utf8_decoding) {
	      $part->body=utf8_decode($part->body);
	   }
	   $my_body_show .= modify_text(htmlspecialchars(trim($part->body)))."<br>";
           $text = strip_tags(str_replace("<br>","#mybr#",trim($part->body)));
           $text = preg_replace("/(\015\012)|(\015)|(\012)/","",$text);             $text = str_replace("#mybr#","\r\n",$text);
           $text = my_decodeHTML($text);
           $my_body_plain .= $text;
	}
     }
     $partno++;
   } // end foreach
   $emailbox_array=array($from,$subject,$date,$cc,$bcc,$to,$replyto,0,$priority,$mail_structure,'',$mail_attachments,$gpg_signature,$gpg_decrypt);
   $result=array($my_body_plain,$my_body_show,$emailbox_array);
   return $result;
}

function make_emailbox_html($thearray) {
  global $msg_no,$settings_replyto,$settings_fullname,$print,$emailsourcelink,$inline,$MGW,$webmails2,$mysize,$word_export,$mbox_id,$global_row;
  global $back_button;

  list($from,$subject,$datum,$cc,$bcc,$to,$replyto,$size,$priority,$mystructure,$attaches3,$attachments2,$gpg_signature,$gpg_decrypt) = $thearray;

  global $replied,$replier2,$forwarded,$user_id,$conn,$realattachments,$account,$message_id;

  $realattachments = $realattachments+count($attachments2);

  if ($to == "") {$to = htmlspecialchars(Lang::getLanguageString("maillist_empty_account"));}
  if ($from == "") {$from = htmlspecialchars(Lang::getLanguageString("maillist_empty_account"));}

  if ($size!=0 and $size!="") {$size = format_filesize($size);}  

  $from = decode_mime_string(shorten($from));
  $to = decode_mime_string(shorten(stripslashes($to)));
  $cc = decode_mime_string(shorten(stripslashes($cc)));
  $bcc = decode_mime_string(shorten(stripslashes($bcc)));

  if ($subject=="") { $subject = "(no subject)"; }

  if ($priority == 2 or $priority == 1) {$subject_html = '<font color="#ff0000"><b>'.$subject.'</b></font>';} else {$subject_html = $subject;}
  $mystring = "

 <table width='100%' border='0' cellspacing='0' cellpadding='0'>
 <tr bgcolor='#D1D1D1'><td>
 &nbsp;</td><td bgcolor='#D1D1D1'><font color='#4E4E4E'><b> ".$from." - ".$subject."</b></font>
 ";

  if ($print!="true") {
    $mystring .= "
	&nbsp; <a href='../contact/index.php?mod=contact&obj=person&view=newform&wm2_contact=".$from."&".SID."' target='_blank'><img src='templates/default/media/contacts.gif' alt='' border='0' align='absmiddle'></a>
  ";
  }

  $mystring .= "
 </td></tr></table>

 <img src='templates/default/media/spacer.gif' alt='' width='1' height='5' border='0'><br>
 <table width='100%' border='0' cellspacing='0' cellpadding='1' bgcolor='#B6B6B6'>
 <tr>
  <td>
    <table width='100%' border='0' cellspacing='0' cellpadding='1' bgcolor='#DFDFDF'><tr><td valign='top'>

	  <table width='100%' border='0' cellspacing='0' cellpadding='0'>
 ";

  if ($print=="true") {
    $mystring .= "
      <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left' nowrap valign='top'><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("maillist_subject")."</font></b></td>
        <td width='2%' align='center' nowrap valign='top'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'>".$subject_html."</td>
      </tr>
      <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left' nowrap><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("maillist_date")."</font></b></td>
        <td width='2%' align='center' nowrap><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%' nowrap>".getDateString_full(strtotime($datum))."</td>
      </tr>
 ";
  }

  if ($size!=0 and $print=="true") {
    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
		<td width='20%' align='left' nowrap><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("maillist_size")."</font></b></td>
		<td width='2%' align='center' nowrap><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
		<td width='78%' nowrap>".$size."</td>
	  </tr>
 ";}

  $from1 = str_replace(array("&quot;","&gt;","&lt;"),array("\"",">","<"),$from);
  $Mail_RFC822 = new Mail_RFC822();
  $Mail_RFC822->validate=false;
  $from2 = $Mail_RFC822->parseAddressList(strtolower($from1)." (abc)", '', TRUE);
//  $from2 = explode(" ",str_replace("&gt;","",str_replace("&lt;","",$from)));

  if (PEAR::isError($from2)) {
       show_webmail_error($back_button.Lang::getLanguageString("readmessage_error_decode"),$from2->message);
  }

  if ((count($settings_replyto)==0 or count($settings_replyto) > 1 or !in_array(strtolower($from2[0]->mailbox."@".$from2[0]->host),$settings_replyto)) and $print=="true") {
    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
		<td width='20%' align='left' valign='top'><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("maillist_from")."</font></b></td>
		<td width='2%' align='center' valign='top'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
		<td width='78%'>".$from."</td>
	  </tr>
 ";}

  $to1 = str_replace(array("&quot;","&gt;","&lt;"),array("\"",">","<"),$to);
  $to2 = $Mail_RFC822->parseAddressList(strtolower($to1)." (abc)", '', FALSE);
//  $to2 = explode(" ",str_replace("&gt;","",str_replace("&lt;","",$to)));
//  if (count($settings_replyto) > 1 or count($settings_replyto) < 1 or (count($settings_replyto)==1 and !in_array(strtolower($to2[0]),$settings_replyto))) {

  if (count($settings_replyto) != 1 or (count($settings_replyto)==1 and !in_array(strtolower($to2[0]->mailbox."@".$to2[0]->host),$settings_replyto))) {

    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left' valign='top' nowrap><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("maillist_to");

    if ($replyto==$to) {$mystring .= " / ".Lang::getLanguageString("webmail2_func_replyto");}
    $mystring .= "
		</font></b></td>
        <td width='2%' align='center' valign='top'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'>".make_contact_links($to)."</td>
      </tr>
 ";}

  if ($cc!="") {
    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left' valign='top'><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("webmail2_func_copyto")."</font></b></td>
        <td width='2%' align='center' valign='top'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'>".make_contact_links($cc)."</td>
      </tr>
 ";}

  if ($bcc!="") {
    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left'><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("webmail2_func_blindcopyto")."</font></b></td>
        <td width='2%' align='center'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'>".make_contact_links($bcc)."</td>
      </tr>
 ";}


  if ($from!=$replyto and $replyto!="" and $replyto!=$to) {
    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left'><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("webmail2_func_replyto")."</font></b></td>
        <td width='2%' align='center'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'>".make_contact_links($replyto)."</td>
      </tr>
 ";}

  if ($mystructure!="" and $mysize!="" and $print!="true" and !$MGW->settings["wm2_show_size_in_maillist"]) {
    $mystring .= "
	  <tr bgcolor='#DFDFDF'>
		<td width='20%' align='left' nowrap><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("maillist_size")."</font></b></td>
		<td width='2%' align='center' nowrap><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
		<td width='78%' nowrap>".$mysize."</td>
	  </tr>
 ";}

// small fix by Franky
  //if ($attaches3!=0 && count($attachments2) != 0) {
  if (count($attachments2) != 0) {
    $mystring .= "
      <tr bgcolor='#DFDFDF'>
        <td width='20%' align='left' nowrap valign='top'><b><font color='#4E4E4E'>&nbsp;".Lang::getLanguageString("sendmail_attachments")."</font></b></td>
        <td width='2%' align='center' nowrap valign='top'><b><font color='#4E4E4E'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%' nowrap>
  ";
    foreach ($attachments2 as $attachment) {
  
      if ($MGW->settings["wm2_performvirusscan"]) {
	$mytarget = "virusscan.php"; 
	$mytarget2 = "virusscan.php"; 
	$mytarget3 = "virusscan.php";
      } else {
	$mytarget = "download.php";
	$mytarget2 = "download2.php";
	$mytarget3 = "download3.php";
      }
      if ($attachment[5]=="yes") {
	if ($MGW->settings["wm2_performvirusscan"]) {
	  $alert = "";
	} else {
	  $alert = 'onclick="alert(\''.$attachment[2][1].'\');"';
	}
      } else { $alert = ""; }
      if (!isset($attachment[2]) or !is_array($attachment[2])) {$attachment[2][0] = "";}
      $showlink = true;
      $ext = strtolower(substr($attachment[0],-strpos(strrev($attachment[0]),'.')));
      if (trim($MGW->settings["wm2_disable_ext"])!="") {
	$myext = explode(",",strtolower(trim($MGW->settings["wm2_disable_ext"])));
	foreach ($myext as $ext2) {
	  $ext2 = trim(str_replace(array("\r","\n"),array("",""),$ext2));
	  if ($ext2 == $ext) {
	    $showlink = false;
	    break;
	  }
	}
      }
      $long_name = $attachment[0];
      if ($attachment[0]!="" and strlen($attachment[0]) > 40) {
	$ext = strtolower(substr($attachment[0],-strpos(strrev($attachment[0]),'.')));
	if ($ext != "") { $ext = ".".$ext; }
	if (strlen($attachment[0]) > (strlen($ext)+41)) {
	  $attachment[0] = substr($attachment[0],0,40)." ... ".$ext;
	}
      }
      if ($print=="true") {
	$mystring .= urldecode($attachment[0])." ( ".$attachment[1]." )<br>";
      } elseif ($showlink) {
	$mystring .= "<a ".$alert." target=\"_blank\" href=\"".$mytarget."?account=".$account."&message_id=".rawurlencode($message_id)."&thefilename=".rawurlencode($long_name)."&msg_id=".rawurlencode($msg_no)."&partno=".rawurlencode($attachment[4])."&".SID."\">".urldecode($attachment[0])."</a>&nbsp;&nbsp;( ".$attachment[1]." ) ";
	if (isModuleInstalled("files")) {
	  $mystring .= '<a '.$alert.' target="_top" href="'.$mytarget2."?save_in=files&account=".$account."&message_id=".rawurlencode($message_id)."&thefilename=".rawurlencode($long_name)."&msg_id=".rawurlencode($msg_no)."&partno=".rawurlencode($attachment[4])."&".SID.'"><img src="templates/default/media/disc.gif" alt="'.Lang::getLanguageString("readmessage_copy_to_files_module").'" width="16" height="9" border="0"></a>';
	}
	$mystring .=  " ".$attachment[2][0]."<br>";
      } else {
	$mystring .= urldecode($attachment[0])." ( ".$attachment[1]." ) <font color='#FF0000'><b>".Lang::getLanguageString("readmessage_disabled_ext")."</b></font><br>";
      }
    }
    $mystring .= "</td></tr>";
  }

  $replying = "";
  if (is_array($replied) and isset($replied[0])) {
    foreach ($replied as $replier) {
      if ($replying!="") {$replying .= "<br>";}
      if (isset($replier[0]) and isset($replier[1]) and is_numeric($replier[0])) {

	$sql = "select mbox_id from mgw_webmail2_messages where message_id=".(int)$replier[2];
	if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
	$row = $res->FetchRow();

	if ($row["mbox_id"]!="") {
	  $replying .= '<a href="maillist.php?mbox_id='.$row["mbox_id"].'&msg_begin=1&markmessage='.$replier[2].'" target="maillist">'.$replier[1]."</a>&nbsp;(".getDateString($replier[0]).")";
	} else {
	  $replying .= $replier[1]."&nbsp;(".getDateString($replier[0]).")";
	}

      }
    }
    $mystring .= "
	  <tr><td><img src='templates/default/media/spacer.gif' alt='' width='1' height='10' border='0'></td></tr>
	  <tr bgcolor='#cceecc'>
        <td width='20%' align='left' valign='top'><b><font color='#000080'>&nbsp;".Lang::getLanguageString("webmail2_funcs_replied")."</font></b></td>
        <td width='2%' align='center' valign='top'><b><font color='#000080'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'><font color='#000080'>".$replying."</font></td>
      </tr>
  ";
  }

  $forwarding = "";
  if (is_array($forwarded) and isset($forwarded[0])) {
    foreach ($forwarded as $forwarder) {
      if ($forwarding!="") {$forwarding .= "<br>";}
      if (isset($forwarder[0]) and isset($forwarder[1]) and is_numeric($forwarder[0])) {

	$sql = "select mbox_id from mgw_webmail2_messages where message_id=".(int)$forwarder[2];
	if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
	$row = $res->FetchRow();

	if ($row["mbox_id"]!="") {
	  $forwarding .= '<a href="maillist.php?mbox_id='.$row["mbox_id"].'&msg_begin=1&markmessage='.$forwarder[2].'" target="maillist">'.$forwarder[1].'</a>&nbsp;('.getDateString($forwarder[0]).')';
	} else {
	  $forwarding .= $forwarder[1].'&nbsp;('.getDateString($forwarder[0]).')';
	}

      }
    }
    if ($replying=="") {
      $mystring .= '<tr><td><img src="templates/default/media/spacer.gif" alt="" width="1" height="10" border="0"></td></tr>';
    } else {
      $mystring .= '<tr><td><img src="templates/default/media/spacer.gif" alt="" width="1" height="5" border="0"></td></tr>';
    }
    $mystring .= "
	  <tr bgcolor='#cceecc'>
        <td width='20%' align='left' valign='top'><b><font color='#000080'>&nbsp;".Lang::getLanguageString("webmail2_funcs_forwarded")."</font></b></td>
        <td width='2%' align='center' valign='top'><b><font color='#000080'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'><font color='#000080'>".$forwarding."</font></td>
      </tr>
  ";
  }

  if ($replier2 != "" and is_numeric($replier2)) {

    $sql = "select header_subject,mbox_id from mgw_webmail2_messages where message_id=".(int)$replier2;
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    $row = $res->FetchRow();

    $repl_subject = htmlspecialchars(decode_mime_string($row["header_subject"]));
  
    if ($row["mbox_id"]!="") {
      $replying2 = '<a href="maillist.php?mbox_id='.$row["mbox_id"].'&msg_begin=1&markmessage='.$replier2.'" target="maillist">'.$repl_subject.'</a>';
      $mystring .= "
	  <tr><td><img src='templates/default/media/spacer.gif' alt='' width='1' height='10' border='0'></td></tr>
	  <tr bgcolor='#cceecc'>
        <td width='20%' align='left'><b><font color='#000080'>&nbsp;Source</font></b></td>
        <td width='2%' align='center'><b><font color='#000080'>:&nbsp;&nbsp;</font></b></td>
        <td width='78%'><font color='#000080'>".$replying2."</font></td>
      </tr>
    ";
    }
  }

  if ($print!="true" and count($webmails2)!=0) {
    if ($inline!="false") {
      $myinline = '<a href="readmessage.php?inline=false&msg_no='.$msg_no.'">'.Lang::getLanguageString("readmessage_disactivate_inline").'</a>';
    } else {
      $myinline = '<a href="readmessage.php?inline=true&msg_no='.$msg_no.'">'.Lang::getLanguageString("readmessage_activate_inline").'</a>';
    }
  } else {$myinline = "";}
  $mystring .= "</table></td>";

  if (count($gpg_signature)>0 and $gpg_signature[0]=="ok" and strpos(strtolower($gpg_signature[1]),strtolower($from2[0]->mailbox."@".$from2[0]->host))) {
    $mystring .= "<td align='right'><a href='#' onclick=\"alert('".$gpg_signature[1]."');\"><img src='".ROOTURL."/modules/webmail2/templates/default/media/sign.gif' border='0'></a></td>";
  } else if (count($gpg_signature)>0 and ($gpg_signature[0]=="bad" or $gpg_signature[0]=="ok")) {
    $mystring .= "<td align='right'><a href='#' onclick=\"alert('".$gpg_signature[1]."');\"><img src='".ROOTURL."/modules/webmail2/templates/default/media/unsign.gif' border='0'></a></td>";
  }

  if (count($gpg_decrypt)>0 and $gpg_decrypt[0]=="ok" and strpos(strtolower($gpg_decrypt[1]),strtolower($from2[0]->mailbox."@".$from2[0]->host))) {
    if (strpos(strtolower($gpg_decrypt[1]),strtolower($from2[0]->mailbox."@".$from2[0]->host)) and strpos(strtolower($gpg_decrypt[1]),"good signature")) {
      $mystring .= "<td align='right'><a href='#' style='text-decoration:none' onclick=\"alert('".$gpg_decrypt[1]."');\"><img src='".ROOTURL."/modules/webmail2/templates/default/media/sign.gif' border='0' align='absmiddle'>&nbsp; <img src='".ROOTURL."/modules/webmail2/templates/default/media/enc.gif' border='0' align='absmiddle'></a></td>";
    } else {
      $mystring .= "<td align='right'><a href='#' onclick=\"alert('".$gpg_decrypt[1]."');\"><img src='".ROOTURL."/modules/webmail2/templates/default/media/enc.gif' border='0'></a></td>";
    }
  } else if (count($gpg_decrypt)>0 and ($gpg_decrypt[0]=="bad" or $gpg_decrypt[0]=="ok")) {
    $mystring .= "<td align='right'><a href='#' onclick=\"alert('".$gpg_decrypt[1]."');\"><img src='".ROOTURL."/modules/webmail2/templates/default/media/unsign.gif' border='0'></a></td>";
  }

  if ($mystructure!="" and $print!="true") {
    $mystring .= "<td bgcolor='#DFDFDF' align='right' valign='top'><font style='font-size: 11px' color='#4E4E4E'>";
    if ($MGW->settings["wm2_enabledownload"] and $MGW->settings["wm2_showstructure"]) {
      if (count($mystructure) < 4) {$thecount = "3";} else {$thecount = "3";}
      $mystring .= $emailsourcelink."<b>".Lang::getLanguageString("webmail2_func_structure")."</b></a><br>";
      if (count($mystructure) > 1) {
	$mystring .= "
	    <select size=\"".$thecount."\" style=\"font-size: 11px; width: 230px; color: #4E4E4E; background-color:'#DFDFDF'\">";
	foreach ($mystructure as $strucitem) {
	  $mystring .= "<option>".$strucitem;
	}	
	$mystring .= "</select>";
      }
    } elseif ($MGW->settings["wm2_enabledownload"]) {
      $mystring .= $emailsourcelink."<b>".Lang::getLanguageString("webmail2_func_emailsource")."</b></a>";  
    } elseif ($MGW->settings["wm2_showstructure"]) {
      if (count($mystructure) > 1) {
	if (count($mystructure) < 4) {$thecount = "3";} else {$thecount = "3";}
	$mystring .= "<!--<b>".Lang::getLanguageString("webmail2_func_structure")."</b><br>-->
	    <select size=\"".$thecount."\" style=\"font-size: 11px; width: 150px; color: #4E4E4E; background-color:'#DFDFDF'\">";
	foreach ($mystructure as $strucitem) {
	  $mystring .= "<option>".$strucitem;
	}	
	$mystring .= "</select>";
      }
    }
    if ($myinline!="" and ($MGW->settings["wm2_enabledownload"] or $MGW->settings["wm2_showstructure"])) {$mystring .= "<br><br>";}
    $mystring .= $myinline."</font></td>";
  }
  $mystring .= "</tr></table></td></tr></table><br>";

  if ($print == "true" and $word_export == "true") {
    $mystring = preg_replace(array("'<a[^>]*?>(.*?)</a[^>]*?>'si"),array("\\1"),$mystring);
  }

  return $mystring;
}

function modify_html($text) {
	
  global $MGW;

  if ($MGW->settings["wm2_securehtmlmails"]) $text = clean_html($text);
/*
  $i = 0;
  $start = 0;
  $len = strlen($text);

  // echo strlen($text)."<br>";

  while ($len>=0) {

    $step = 10000;  
    $subtext[$i] = substr($text,$start,$step);
    $start = $start + $step;
    $len = $len - $step;

    $pattern = '=(.*)<a.[^>]*href\=[ ]*[\'"]([^#"]*)[\'"][^>]*>(.*)</a>(.*)=msiU';
    $subtext[$i] = preg_replace_callback($pattern, "modify_my_callback", $subtext[$i]);

    $pattern = '=(.*)<img(.*)src\=[ ]*[\'"]([^"]*)[\'"](.*)>(.*)=msiU';
    $repl = '\\1<img\\2\\4 src="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=\\3">\\5';
    $subtext[$i] = preg_replace($pattern, $repl, $subtext[$i]);
    $pattern = '=(.*)background(.*)src\=[ ]*[\'"]([^"]*)[\'"](.*)>(.*)=msiU';
    $repl = '\\1<img\\2 src="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=\\3"\\4>\\5';
    $subtext[$i] = preg_replace($pattern, $repl, $subtext[$i]);

    $i++;
  }

  $text = "";
  for ($i2=0;$i2<$i;$i2++) {
    $text .= $subtext[$i2];
  }
*/
  $pattern = '=(.*)<a.[^>]*href\=\s*[\'"]([^#"]*)[\'"][^>]*>(.*)</a>(.*)=msiU';
  $text = preg_replace_callback($pattern, "modify_my_callback", $text);

  $pattern = '=(.*)<img(.*)src\=\s*[\'"]([^"]*)[\'"](.*)>(.*)=msiU';
  $repl = '\\1<img\\2\\4 src="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=\\3">\\5';
  $text = preg_replace($pattern, $repl, $text);
  $pattern = '=(.*)background(.*)\=\s*[\'"]([^"]*)[\'"](.*)>(.*)=msiU';
  $repl = '\\1background\\2 ="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=\\3"\\4>\\5';
  $text = preg_replace($pattern, $repl, $text);

  /*
   $text = substr($text,0,15000);

   $pattern = '=(.*)<a.*href\=[ ]*[\'"]([^#"]*)[\'"][^>]*>(.*)</a>(.*)=msiU';
   $repl = '\\1<a target="_blank" href="norefer.php?url=\\2">\\3</a>\\4';
   $text = preg_replace_callback($pattern, "modify_my_callback", $text);

   $pattern = '=(.*)<img(.*)src\=[ ]*[\'"]([^"]*)[\'"][^>](.*)>(.*)=msiU';
   $repl = '\\1<img\\2\\4 src="noimg.php?download='.$MGW->settings["wm2_dontdownloadobjects"].'&url=\\3">\\5';
   $text = preg_replace($pattern, $repl, $text);
  */
  return $text;
}

function modify_my_callback($s) {

  if (strpos("@".$s[2],"mailto:")==1) {
    $repl = $s[1].'<a target="rightframe" href="sendmail.php?to='.str_replace("mailto:","",addslashes(strip_tags($s[2]))).'">'.$s[3].'</a>'.$s[4];
  } else {
    $repl = $s[1].'<a target="_blank" href="norefer.php?url='.addslashes(strip_tags($s[2])).'">'.$s[3].'</a>'.$s[4];
  }
  
  return $repl;
}

function modify_text($text) {
  global $MGW;

  //$text = ereg_replace("([_]+){2,}","<hr size=\"1\">",$text);
  //	$text = preg_replace("/(\012)/","",$text);
  $text = preg_replace("/(\015\012)|(\015)|(\012)/","<br>\n",$text);
  $text = wordwrap($text,130,"<br>",1);
  $text = str_replace("<<br>br>","<br>",$text);
  $text = str_replace("<b<br>r>","<br>",$text);
  $text = str_replace("<br<br>>","<br>",$text);
  $text = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]","<a target=\"_blank\" href=\"norefer.php?url=\\0\">\\0</a>", $text);
  $text = ereg_replace("([A-Za-z0-9_.\-]+\@[A-Za-z0-9_\.\-]+[.]+[a-zA-Z]+)","<a target='rightframe' href=\"sendmail.php?to=\\1\">\\1</a>",$text);
  //	$text = ereg_replace("([A-Za-z0-9_.\-]+\@[A-Za-z0-9_\-\.]+[.]+[a-zA-Z]+)","<a target='rightframe' href=\"sendmail.php?to=\\1\">\\1</a>",$text);

  if ($MGW->settings["wm2_show_emoticons"]) {
    $text = str_replace(":)",'<img src="templates/default/media/emoti1.gif" alt=":)" width="19" height="19" border="0" align="absmiddle">',$text);
    $text = str_replace(":-)",'<img src="templates/default/media/emoti1.gif" alt=":-)" width="19" height="19" border="0" align="absmiddle">',$text);

    $text = str_replace(":-(",'<img src="templates/default/media/emoti2.gif" alt=":-(" width="19" height="19" border="0" align="absmiddle">',$text);
    $text = str_replace(":(",'<img src="templates/default/media/emoti2.gif" alt=":(" width="19" height="19" border="0" align="absmiddle">',$text);

    $text = str_replace(";-)",'<img src="templates/default/media/emoti3.gif" alt=";-)" width="19" height="19" border="0" align="absmiddle">',$text);
    $text = str_replace(":-P",'<img src="templates/default/media/emoti4.gif" alt=":-P" width="19" height="19" border="0" align="absmiddle">',$text);
    $text = str_replace(":-D",'<img src="templates/default/media/emoti5.gif" alt=":-D" width="19" height="19" border="0" align="absmiddle">',$text);
    $text = str_replace(":-[",'<img src="templates/default/media/emoti6.gif" alt=":-[" width="19" height="19" border="0" align="absmiddle">',$text);
    $text = str_replace(":-\\",'<img src="templates/default/media/emoti7.gif" alt=":-\" width="19" height="19" border="0" align="absmiddle">',$text);
  }
  return $text;
}

function modify_text2($text) {

  $text = preg_replace("/(\015\012)|(\015)|(\012)/","<br>\n",$text);
  $text = wordwrap($text,130,"<br>",1);
  $text = str_replace("<<br>br>","<br>",$text);
  $text = str_replace("<b<br>r>","<br>",$text);
  $text = str_replace("<br<br>>","<br>",$text);
  $text = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]","<a target=\"_blank\" href=\"norefer.php?url=\\0\">\\0</a>", $text);
  $text = ereg_replace("([A-Za-z0-9_.\-]+\@[A-Za-z0-9_\.\-]+[.]+[a-zA-Z]+)","<a target='rightframe' href=\"sendmail.php?to=\\1\">\\1</a>",$text);

  return $text;
}

?>
