<?php
  /*
   This file is part of Thomas Bley's moregroupware webmail2/calendar2/admin2 module. (tb-mgw)

   More information:
   -----------------

   Simple Groupware Solutions Thomas Bley
   Fichtenstr. 23
   Germany, 85640 Putzbrunn

   Contact:
   --------

   info@simple-groupware.de

   http://www.simple-groupware.de


   Copyright 2002-2003 Thomas Bley
   tb-mgw is distributed under the terms of the GNU General Public License 

   tb-mgw is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   tb-mgw is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with tb-mgw; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

  // webmail2_settings_editaccount
  // Moregroupware.org

/* CVS comments:
   *
   * $Id: webmail2_settings_editaccount.php,v 1.29 2006/01/03 22:14:31 k-fish Exp $
   *
   * $Author: k-fish $
   *
   * $Log: webmail2_settings_editaccount.php,v $
   * Revision 1.29  2006/01/03 22:14:31  k-fish
   * Added a patch that fixes a problem when editing account settings as user. Thanks to Thomas Knorr.
   *
   * Revision 1.5  2005/12/31 13:07:19  Thomas Knorr
   * bugfix, userdata are now updated if usermaychange == checked
   *
   * Revision 1.4  2005/12/29 23:28:22  Thomas Knorr
   * made the code more readable, nobody needs lines with more than 1000 characters
   *
   * Revision 1.3  2005/12/29 10:32:26  Thomas Knorr
   * changed sql query for updating only a small set if user_maychange==no
   *
   */


  // =================================================
  //	              Formular Mail-Editaccount
  // =================================================
require_once(INCLUDEPATH . "crypt.inc.php");
require_once(INCLUDEPATH . "mSelectBox.class.php");
include(WM2_INC_DIR.'accounts_inc.php');

error_reporting  (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

function formatforform_assign ($myarray,$smarty) {
  foreach ($myarray as $key=>$item) {
    $smarty->assign($key, htmlspecialchars(stripslashes(myquote($item))));
  }
}

function editaccount($conn,$smarty,$account)
{
  global $user_id,$username,$MGW;

  if ($username == "admin") {
    $sql = "select * from mgw_webmail2_accounts where id=".(int)$_GET["account"];
  } else {
    $sql = "select * from mgw_webmail2_accounts where id=".(int)$_GET["account"]." and user_id=".(int)$user_id;
  }
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  $row = $res->FetchRow();

  $sql = "select username from mgw_users where id=".(int)$row["user_id"];
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  $row2 = $res->FetchRow();
  $username2 = $row2["username"];
	
  $myC = new Crypto();
  $wm2_password = $myC->decrypt($username2, $row["password"]);
  $wm2_smtppassword = $myC->decrypt($username2, $row["smtppassword"]);

  if ($row["servertype"]=="wm2_servertype_pop3") {
    $smarty->assign("wm2_servertype_pop3","selected");
    $smarty->assign("wm2_servertype_imap","");
    $smarty->assign("wm2_servertype_imap_only","");
  } else if ($row["servertype"]=="wm2_servertype_imap") {
    $smarty->assign("wm2_servertype_pop3","");
    $smarty->assign("wm2_servertype_imap","selected");
    $smarty->assign("wm2_servertype_imap_only","");
  } else {
    $smarty->assign("wm2_servertype_pop3","");
    $smarty->assign("wm2_servertype_imap","");
    $smarty->assign("wm2_servertype_imap_only","selected");
  }

  $smarty->assign("wm2_users", getallusers());
  $smarty->assign("wm2_user", $username);
  $smarty->assign("wm2_the_user_id", $row["user_id"]);
  $smarty->assign("wm2_username2", $username2);

  

    
  $vars = array(
		"wm2_password"        => $wm2_password,
		"wm2_mailboxname"     => $row["mailboxname"],
		"wm2_fullname"        => $row["fullname"],
		"wm2_signature"        => $row["signature"],
		"wm2_signature_html"        => $row["signature_html"],
		"wm2_imap_list_all" => $row["imap_list_all"],
		"wm2_imap_show_numbers" => $row["imap_show_numbers"],
		"wm2_replyto"         => $row["replyto"],
		"wm2_pophost"         => $row["pophost"],
		"wm2_popport"         => $row["popport"],
		"wm2_usemailfunction" => $row["usemailfunction"],
		"wm2_smtphost"        => $row["smtphost"],
		"wm2_smtpport"        => $row["smtpport"],
		"wm2_popbeforesmtp"   => $row["popbeforesmtp"],
		"wm2_smtpauth"        => $row["smtpauth"],
		"wm2_smtpusername"    => $row["smtpusername"],
		"wm2_smtppassword"    => $wm2_smtppassword,
		"wm2_smtpusepopuser"  => $row["smtpusepopuser"],
		"wm2_username"        => $row["username"],
		"wm2_leavemessages"   => $row["leavemessages"],
		"wm2_target_folder"   => $row["target_folder"],
		"wm2_delete_local_remote"   => $row["delete_local_remote"],
		"wm2_activated"       => $row["activated"],
		"wm2_usermaychange"   => $row["usermaychange"],
		"wm2_enable_ssl"      => $row["enable_ssl"],
		"wm2_enable_ssl_smtp" => $row["enable_ssl_smtp"],
		"wm2_use_local_trash"      => $row["use_local_trash"],
		"wm2_use_local_sent"      => $row["use_local_sent"],
		"wm2_enable_smtp" 	=> $row["enable_smtp"],
		);
  formatforform_assign($vars,&$smarty);

  $folders=array();
  $sorted_folders=array();
  $messagecount=0;
  list($folders,$sorted_folders,$messagecount)=get_mailfolders();
  $smarty->assign("folders",$sorted_folders);

  $smarty->assign("php_version", str_replace(".","",PHP_VERSION));

  $smarty->assign('action',"editaccountsave");
  $smarty->assign('account',$_GET["account"]);
  $smarty->assign("suname","editaccountsave");
  $smarty->assign("suclass","submit");
  $smarty->assign("language", $MGW->spkz);

  $smarty->display('webmail2_settings_editaccount.tpl');
  die;
}

function editaccountsave()
{
  global $conn;
  global $user_id,$username;
	
  $myvars = array(
		"wm2_usermaychange",		"wm2_popbeforesmtp",
	  	"wm2_enable_ssl",			"wm2_enable_ssl_smtp",
		"wm2_enable_smtp",			"wm2_use_local_trash",
		"wm2_use_local_sent",		"wm2_usemailfunction",
		"wm2_smtpauth",				"wm2_smtpusername",
		"wm2_smtpusepopuser",		"wm2_fullname",
		"wm2_signature",			"wm2_signature_html",
		"wm2_replyto",				"wm2_servertype",
		"wm2_pophost",				"wm2_popport",
		"wm2_smtphost",				"wm2_smtpport",
		"wm2_username",				"wm2_leavemessages",
		"wm2_delete_local_remote", 	"account",
		"wm2_activated",			"wm2_password",
		"wm2_smtppassword", 		"the_user_id",
		"wm2_imap_list_all", 		"wm2_imap_show_numbers",
		"wm2_target_folder");

  foreach ($myvars as $thevar) {
    ${$thevar} = (isset($_GET[$thevar])) ? $_GET[$thevar] : (isset($_POST[$thevar]) ? $_POST[$thevar] : "");
  }

  $vars = array("usermaychange","fullname","signature","signature_html","replyto","pophost","popport","smtphost","smtpport","username","smtpusername","imap_list_all","imap_show_numbers");
  foreach ($vars as $item) {
    ${"wm2_".$item} = myquote(${"wm2_".$item});
  }

  $sql = "select user_id,usermaychange from mgw_webmail2_accounts where id=".(int)$account;
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  $row = $res->FetchRow();
  $the_user_id = $row["user_id"];
  $wm2_usermaychange = $row["usermaychange"]; 
	
  if ($username == "admin") {
    $sql = "select username from mgw_users where id=".(int)$the_user_id;
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    $row = $res->FetchRow();
    $username2 = $row["username"];
  } else {
    $username2 = $username;
  }
	
  $myC	= new Crypto();
  $wm2_password	= $myC->encrypt($username2, $wm2_password);
  $wm2_smtppassword	= $myC->encrypt($username2, $wm2_smtppassword);

  $wm2_signature_html = clean_html($wm2_signature_html);	

  if ($username == "admin") 
  {
   		// the admin may always change everything
    	$sql = "update mgw_webmail2_accounts set ";
    	$sql .= "imap_show_numbers='"	.$wm2_imap_show_numbers."',";
    	$sql .= "imap_list_all='"		.$wm2_imap_list_all."',";
    	$sql .= "usermaychange='"		.$wm2_usermaychange."',";
    	$sql .= "enable_ssl='"			.$wm2_enable_ssl."',";
    	$sql .= "enable_ssl_smtp='"		.$wm2_enable_ssl_smtp."',";
    	$sql .= "use_local_trash='"		.$wm2_use_local_trash."',";
    	$sql .= "use_local_sent='"		.$wm2_use_local_sent."',";
    	$sql .= "enable_smtp='"			.$wm2_enable_smtp."',";
    	$sql .= "popbeforesmtp='"		.$wm2_popbeforesmtp."',";
    	$sql .= "usemailfunction='"		.$wm2_usemailfunction."',";
    	$sql .= "smtpauth='"			.$wm2_smtpauth."',";
    	$sql .= "smtpusername='"		.$wm2_smtpusername."',";
    	$sql .= "smtppassword="			.$conn->Quote($wm2_smtppassword).",";
    	$sql .= "smtpusepopuser='"		.$wm2_smtpusepopuser."',";
    	$sql .= "password="				.$conn->Quote($wm2_password).",";
    	$sql .= "fullname='"			.$wm2_fullname."',";
    	$sql .= "signature='"			.$wm2_signature."',";
    	$sql .= "signature_html='"		.$wm2_signature_html."',";
    	$sql .= "replyto='"				.$wm2_replyto."',";
    	$sql .= "servertype='"			.$wm2_servertype."',";
    	$sql .= "pophost='"				.$wm2_pophost."',";
    	$sql .= "popport='"				.$wm2_popport."',";
    	$sql .= "smtphost='"			.$wm2_smtphost."',";
    	$sql .= "smtpport='"			.$wm2_smtpport."',";
    	$sql .= "username='"			.$wm2_username."',";
    	$sql .= "leavemessages='"		.$wm2_leavemessages."',";
    	$sql .= "delete_local_remote='"	.$wm2_delete_local_remote."',";
    	$sql .= "activated='"			.$wm2_activated."',";
    	$sql .= "target_folder="		.(int)$wm2_target_folder;

    	$sql .= " where id=" .(int)$account;

  } 
  else 
  {

	
    if ($wm2_usermaychange == "checked")
	{

		// the user may change everything if allowed
    	$sql = "update mgw_webmail2_accounts set ";
    	$sql .= "imap_show_numbers='"	.$wm2_imap_show_numbers."',";
    	$sql .= "imap_list_all='"		.$wm2_imap_list_all."',";
    	$sql .= "usermaychange='"		.$wm2_usermaychange."',";
    	$sql .= "enable_ssl='"			.$wm2_enable_ssl."',";
    	$sql .= "enable_ssl_smtp='"		.$wm2_enable_ssl_smtp."',";
    	$sql .= "use_local_trash='"		.$wm2_use_local_trash."',";
    	$sql .= "use_local_sent='"		.$wm2_use_local_sent."',";
    	$sql .= "enable_smtp='"			.$wm2_enable_smtp."',";
    	$sql .= "popbeforesmtp='"		.$wm2_popbeforesmtp."',";
    	$sql .= "usemailfunction='"		.$wm2_usemailfunction."',";
    	$sql .= "smtpauth='"			.$wm2_smtpauth."',";
    	$sql .= "smtpusername='"		.$wm2_smtpusername."',";
    	$sql .= "smtppassword="			.$conn->Quote($wm2_smtppassword).",";
    	$sql .= "smtpusepopuser='"		.$wm2_smtpusepopuser."',";
    	$sql .= "password="				.$conn->Quote($wm2_password).",";
    	$sql .= "fullname='"			.$wm2_fullname."',";
    	$sql .= "signature='"			.$wm2_signature."',";
    	$sql .= "signature_html='"		.$wm2_signature_html."',";
    	$sql .= "replyto='"				.$wm2_replyto."',";
    	$sql .= "servertype='"			.$wm2_servertype."',";
    	$sql .= "pophost='"				.$wm2_pophost."',";
    	$sql .= "popport='"				.$wm2_popport."',";
    	$sql .= "smtphost='"			.$wm2_smtphost."',";
    	$sql .= "smtpport='"			.$wm2_smtpport."',";
    	$sql .= "username='"			.$wm2_username."',";
    	$sql .= "leavemessages='"		.$wm2_leavemessages."',";
    	$sql .= "delete_local_remote='"	.$wm2_delete_local_remote."',";
    	$sql .= "activated='"			.$wm2_activated."',";
    	$sql .= "target_folder="		.(int)$wm2_target_folder;

    	$sql .= " where id=".(int)$account." and user_id=".(int)$user_id;
	}
	else
	{	// only update a small set, what is allowed
		$sql = "update mgw_webmail2_accounts set ";
    	$sql .= "imap_show_numbers='".$wm2_imap_show_numbers."',";
    	$sql .= "signature='".$wm2_signature."',";
    	$sql .= "signature_html='".$wm2_signature_html."',";
    	$sql .= "target_folder=".(int)$wm2_target_folder;
    	$sql .= " where id=".(int)$account." and user_id=".(int)$user_id;
  }
  }

  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
}

function deleteaccount($conn,$smarty,$account)
{
  global $user_id,$username;

  if ($username == "admin") {
    $sql = "delete from mgw_webmail2_accounts where mailboxname!='default' and id=".(int)$_GET["account"];
  } else {
    $sql = "delete from mgw_webmail2_accounts where mailboxname!='default' and id=".(int)$_GET["account"]." and user_id=".(int)$user_id;
  }
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
}
?>
